<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Front End</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- DataTables -->
  <link rel="stylesheet" href="plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
</head>
<body class="hold-transition sidebar-mini">
<div class="wrapper">
  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Front End</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">haiongngoai</a>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-table"></i>
              <p>
                Quản trị
                <i class="fas fa-angle-left right"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="index.voucher.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Vouchers</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index.menu.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Menus</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index.drink.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Drinks</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index.countryregion.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Country/Region</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index.userorder.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>User/Order</p>
                </a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-12 text-center">
            <h1>Quản trị Voucher</h1>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <div class="col-12">
            <div class="card">
              <div class="card-body">
                <div class="container">
                  <div class="jumbotron container">
                    <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="voucher-code">Mã Voucher</label>
                    </div>
                    <div class="col-sm-9">
                      <input type="text" id="input-voucher-code" name="vouchercodes" placeholder="Voucher code"
                      class="form-control">
                    </div>
                    </div>
                    <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="discount">Phần trăm giảm giá</label>
                    </div>
                    <div class="col-sm-9">
                      <input type="number" id="input-discount" name="discount" placeholder="Discount" class="form-control">
                    </div>
                    </div>
                    <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="note">Ghi chú</label>
                    </div>
                    <div class="col-sm-9">
                      <input type="text" id="input-note" name="note" placeholder="Note" class="form-control">
                    </div>
                    </div>
                    <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="createDate">Ngày Tạo</label>
                    </div>
                    <div class="col-sm-9">
                      <input type="text" id="input-createDate" name="createDate" placeholder="Create Date" class="form-control" disabled>
                    </div>
                    </div>
                    <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="updateDate">Ngày sửa</label>
                    </div>
                    <div class="col-sm-9">
                      <input type="text" id="input-updateDate" name="updateDate" placeholder="Update Date" class="form-control"disabled>
                    </div>
                    </div>
                    <div class="row">
                    <div class="col-sm-12 text-right">
                      <button id="btn-create-voucher" class="btn btn-info">Add voucher</button>
                      <button id="btn-update-voucher" class="btn btn-success my-3">Update voucher</button>
                      <button id="btn-delete-voucher" class="btn btn-danger">Delete voucher</button>
                    </div>
                    </div>
                  </div>
                </div>
                <table class="table table-bordered table-striped table-hover text-center" id="voucher-table">
                  <thead>
                    <tr>
                      <th>STT</th>
                      <th>Mã giảm giá</th>
                      <th>Phần trăm giảm giá</th>
                      <th>Ghi Chú</th>
                      <th>Ngày tạo</th>
                      <th>Ngày cập nhật</th>
                      <th>Action</th>
                    </tr>
                    <tbody>

                    </tbody>
                </table>
              </div>
            </div>
            <!-- /.card -->
          </div>
          <!-- /.col -->
        </div>
        <!-- /.row -->
      </div>
      <!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<!-- DataTables  & Plugins -->
<script src="plugins/datatables/jquery.dataTables.min.js"></script>
<script src="plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="plugins/jszip/jszip.min.js"></script>
<script src="plugins/pdfmake/pdfmake.min.js"></script>
<script src="plugins/pdfmake/vfs_fonts.js"></script>
<script src="plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
</body>
<script>
  $(document).ready(function(){
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    // định nghĩa table voucher
    var STT = 1;
    const gCOL_ID = 0;
    const gCOL_MA_VOUCHER = 1;
    const gCOL_PHAN_TRAM = 2;
    const gCOL_GHI_CHU = 3;
    const gCOL_DATE_CREATE = 4;
    const gCOL_DATE_UPDATE = 5;
    const gCOL_ACTION = 6;
    var gId;
    var gVoucherObj = {
        maVoucher: "",
        phanTramGiamGia: "",
        ghiChu: "",
        ngayTao: "",
        ngayCapNhat: ""
    }
    const gORDER_COLS = ["id", "maVoucher", "phanTramGiamGia", "ghiChu", "ngayTao", "ngayCapNhat", "action"];
    var vTable = $("#voucher-table").DataTable({
        columns: [
            {data: gORDER_COLS[gCOL_ID]},
            {data: gORDER_COLS[gCOL_MA_VOUCHER]},
            {data: gORDER_COLS[gCOL_PHAN_TRAM]},
            {data: gORDER_COLS[gCOL_GHI_CHU]},
            {data: gORDER_COLS[gCOL_DATE_CREATE]},
            {data: gORDER_COLS[gCOL_DATE_UPDATE]},
            {data: gORDER_COLS[gCOL_ACTION]}
        ],
        columnDefs: [
            {
              targets: gCOL_ID,
              render: function (){
                return STT++;
              }
            },
            {
                targets: gCOL_ACTION,
                className: "text-center",
                defaultContent: '<button class="btn btn-link btn-detail" data-toggle="tooltip" data-placement="bottom" title="Chi Tiet"><i class="far fa-list-alt"></i></button>'
            }
        ],
        searching: false,
    });
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    onPageLoading();
    //gán event cho nút chi tiết
    $("#voucher-table").on("click", ".btn-detail", function() {
        onBtnDetailClick(this);
    });
    // gán sự kiện cho nút create voucher
    $("#btn-create-voucher").on("click", function() {
        onBtnCreateVoucherClick();
    });
    // gán sự kiện cho nút update voucher
    $("#btn-update-voucher").on("click", function() {
        onBtnUpdateVoucherClick();
    });
    // gán sự kiện cho nút delete voucher
    $("#btn-delete-voucher").on("click", function() {
        onBtnDeleteVoucherClick();
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm load trang
    function onPageLoading() {
        callApiShowVoucherDataTable();
    }
    //hàm xử lý sự kiện nút chi tiết
    function onBtnDetailClick(paramElement) {
        "use strict";
        var vVoucherData = getObjectFormButton(paramElement);
        gId = vVoucherData.id;
        console.log("ID: " + gId);
        getAjaxDetailVoucher(gId);
    }
    //hàm thêm voucher click
    function onBtnCreateVoucherClick() {
        console.log("add click");
        //B1: thu  thập dữ liệu
        getDataVoucher(gVoucherObj);
        //B2: validate data
        var vIsValidate = validateData(gVoucherObj);
        if(vIsValidate) {
            //B3: insert user
            callAjaxApiAddVoucher(gVoucherObj);
            //B4: xử lý hiện thị front-end
            //tải lại trang khi xử lý thành công
            location.reload();
        }
    }
    //hàm sửa voucher click
    function onBtnUpdateVoucherClick() {
        console.log("update click");
        //B1: thu  thập dữ liệu
        getDataVoucher(gVoucherObj);
        //B2: validate data
        var vIsValidate = validateData(gVoucherObj);
        if(vIsValidate) {
            //B3: insert user
            callAjaxApiUpdateVoucher(gVoucherObj);
            //B4: xử lý hiện thị front-end
            //tải lại trang khi xử lý thành công
            location.reload();
        }
    }
    //hàm xử lý sự kiện delete voucher click
    function onBtnDeleteVoucherClick() {
        //B1: thu thập dữ liệu (ko có)
        //B2: validate (ko có)
        //B3: delete user
        if(gId == null) {
            alert("Vui lòng chọn voucher cần xóa!");
        } else {
            callAjaxApiDeleteVoucher();
        }
        //B4: xử lý hiện thị front-end
        //tải lại trang khi xử lý thành công
        location.reload();
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function callApiShowVoucherDataTable() {
        $.ajax({
            async: false,
            url: "http://localhost:8080/voucher/all",
            type: "GET",
            dataType: "json",
            success: function(res){
                console.log(res);
                //load
                vTable.clear();
                vTable.rows.add(res);
                vTable.draw();
            },
            error: function(err){
                console.log(err.response);
            }
        })
    }
    //hàm dựa vào button detail xác định được dữ liệu order object
    function getObjectFormButton(paramElement) {
        "use strict";
        var vRowClick = $(paramElement).closest("tr");
        var vDataRow = vTable.row(vRowClick).data();
        return vDataRow;
    }
    //hàm gọi api voucher theo id
    function getAjaxDetailVoucher(paramId) {
        "use strict";
        $.ajax({
            async: false,
            url: "http://localhost:8080/voucher/detail/" + paramId,
            type: "GET",
            dataType: "json",
            success: function(paramRes) {
                console.log(paramRes);
                loadDatetoFrom(paramRes);
            },
            error: function(error) {
                alert(error.responseText);
            }
        });
    }
    //load date lên from voucher
    function loadDatetoFrom(paramVoucherObj) {
        "use strict";
        $("#input-voucher-code").val(paramVoucherObj.maVoucher);
        $("#input-discount").val(paramVoucherObj.phanTramGiamGia);
        $("#input-note").val(paramVoucherObj.ghiChu);
        let vCreateDate = paramVoucherObj.ngayTao.slice(5, 7) + "-" + paramVoucherObj.ngayTao.slice(8,10) + "-" + paramVoucherObj.ngayTao.slice(0, 4);
      $("#input-createDate").val(vCreateDate);
      if(paramVoucherObj.ngayCapNhat !== null){
        let vUpdateDate = paramVoucherObj.ngayCapNhat.slice(5,7) + "-" + paramVoucherObj.ngayCapNhat.slice(8,10) + "-" + paramVoucherObj.ngayCapNhat.slice(0,4);
        $("#input-updateDate").val(vUpdateDate);
      }
      else {
        $("#input-updateDate").val(null);
      }
    }


    //hàm thu thập dữ liệu
    function getDataVoucher(paramVoucherObj) {
        paramVoucherObj.maVoucher = $("#input-voucher-code").val().trim();
        paramVoucherObj.phanTramGiamGia = $("#input-discount").val().trim();
        paramVoucherObj.ghiChu = $("#input-note").val();
    }
    //hàm validate data
    function validateData(paramVoucherObj) {
        "use strict";
        if(paramVoucherObj.maVoucher == "") {
            alert("Bạn chưa nhập ma voucher!");
            return false;
        }
        else if(paramVoucherObj.phanTramGiamGia == "") {
            alert("Bạn chưa nhập phần trăm giảm giá!");
            return false;
        }
        else if(paramVoucherObj.ghiChu == "") {
            alert("Bạn chưa nhập note!");
            return false;
        }
 
        return true;
    }
    //hàm gọi api add voucher
    function callAjaxApiAddVoucher(paramVoucherObj) {
        "use strict";
        $.ajax({
            async: false,
            url: "http://localhost:8080/voucher/create",
            type: "POST",
            data: JSON.stringify(paramVoucherObj),
            contentType: "application/json;charset=UTF-8",
            success: function(paramRes) {
                alert("Thêm voucher thành công!");
            },
            error: function(error) {
                console.log(error.responseText);
            }
        });
    }
    //hàm gọi api update voucher
    function callAjaxApiUpdateVoucher(paramVoucherObj) {
        "use strict";
        $.ajax({
            async: false,
            url: "http://localhost:8080/voucher/update/" + gId,
            type: "PUT",
            data: JSON.stringify(paramVoucherObj),
            contentType: "application/json;charset=UTF-8",
            success: function(paramRes) {
                alert("Sửa voucher thành công!");
            },
            error: function(error) {
                console.log(error.responseText);
            }
        });
    }
    //hàm gọi api delete voucher
    function callAjaxApiDeleteVoucher() {
        "use strict";
        $.ajax({
            async: false,
            url: "http://localhost:8080/voucher/delete/" + gId,
            type: "DELETE",
            success: function() {
                alert("Xóa voucher " + gId + " thành công!");
            },
            error: function(error) {
                console.log(error.responseText);
            }
        });
    }
    
})
</script>
</html>
